import sys
import regex as re
from collections import Counter
from collections import OrderedDict
from itertools import islice

def get_freq_list_sorted_by_len(c):

    items = c.items()

    return OrderedDict(sorted(items, key=lambda t: len(t[0]), reverse=True))


def get_words(t):
    for m in re.finditer(r'[\p{L}0-9\*]+', t):
        yield m.group(0)

file = open('News-Commentary-v16', 'r' )

content = file.read()

myDict = Counter(get_words(content))

sorted_by_len = get_freq_list_sorted_by_len(myDict)


top_10 = list(islice(sorted_by_len, 0, 10))
for i in top_10:
    print(i)
